<template>
  <div class="unusualReason pagePadding">
    <div
      v-if=" powers.some((i) => i == '001')"
    >
      <ex-table
        v-loading="false"
        :table="table"
        :data="tableData"
        :columns="columns"
        :page="pageInfo"
        :size="size"
        @page-curr-change="handlePageChange"
        @page-size-change="handleSizeChange"
        @screen-reset="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
        @screen-submit="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
      >
        <template #table-header="{}">
          <div style="width: 100%">
            <el-row style="padding: 0 0 0 80px">
              <el-col :span="3" style="width: 210px">
                <el-select
                  clearable
                  v-model="parmValue.type"
                  :size="searchSize"
                  placeholder="原因类型"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                >
                  <el-option
                    v-for="item in options"
                    :key="item.id"
                    :label="item.label"
                    :value="item.id"
                  >
                  </el-option>
                </el-select>
              </el-col>
              <el-col :span="3" style="width: 66px; float: right">
                <el-button
                  :size="searchSize"
                  type="primary"
                  style="float: right; margin-left: 5px"
                  @click="searchList"
                >
                  刷新
                </el-button>
              </el-col>
              <el-col :span="4" style="width: 66px; float: right">
                <el-button
                  type="warning"
                  class="fr"
                  :size="searchSize"
                  @click="restSearch"
                >
                  重置
                </el-button>
              </el-col>
              <el-col
                :span="3"
                style="width: 66px; float: right"
                v-if="powers.some((i) => i == '003')"
              >
                <el-button
                  :size="searchSize"
                  type="success"
                  style="float: right; margin-left: 5px"
                  @click="openModal({ id: 'add' }, '003')"
                >
                  新建
                </el-button>
              </el-col>
            </el-row>
          </div>
        </template>
        <template #type="{ scope }">
          <el-tag
            :size="tablebtnSize"
            v-text="
              (options.find((item) => item.id == scope.row.type) || {}).label ||
              '--'
            "
          ></el-tag>
        </template>
        <template #status="{ scope }">
          <el-tag
            :size="tablebtnSize"
            :type="scope.row.status == '0' ? 'warning' : ''"
            v-text="
              (statusOptions.find((item) => item.id == scope.row.status) || {})
                .label || '--'
            "
          ></el-tag>
        </template>
        <template #operation="{ scope }">
          <el-tooltip
            v-if="powers.some((i) => i == '007')"
            effect="dark"
            content="详情"
            placement="top"
          >
            <i
              class="el-icon-view tb-icon"
              @click="openModal(scope.row, '007')"
            ></i>
          </el-tooltip>
          <el-tooltip
            v-if="powers.some((i) => i == '005')"
            effect="dark"
            content="修改"
            placement="top"
          >
            <i
              class="el-icon-edit tb-icon"
              @click="openModal(scope.row, '005')"
            ></i>
          </el-tooltip>
          <el-tooltip
            v-if="
              powers.some((i) => i == '004') && scope.row.status === '1'
            "
            effect="dark"
            content="禁用"
            placement="top"
          >
            <i
              class="el-icon-video-pause tb-icon"
              @click="statusConfirm(scope.row.id, scope.row.status)"
            ></i>
          </el-tooltip>
          <el-tooltip
            v-if="
              powers.some((i) => i == '004') && scope.row.status === '0'
            "
            effect="dark"
            content="启用"
            placement="top"
          >
            <i
              class="el-icon-video-play tb-icon"
              @click="statusConfirm(scope.row.id, scope.row.status)"
            ></i>
          </el-tooltip>
          <el-tooltip
            v-if="powers.some((i) => i == '006')"
            effect="dark"
            content="删除"
            placement="top"
          >
            <i
              class="el-icon-delete tb-icon"
              @click="deleteItem(scope.row.id)"
            ></i>
          </el-tooltip>
        </template>
      </ex-table>
      <add-edit
        :id="modelId"
        :sitem="sitem"
        :show-model="showModel"
        :is-detail="isDetail"
        @refresh="searchList"
        @cancel="showModel = false"
      />
    </div>
    <div v-else>
      <no-auth></no-auth>
    </div>
  </div>
</template>
   <script>
import mixinPage from "@/mixins/elPaginationHandle";
import resToken from "@/mixins/resToken";
import { statusList } from "@/assets/js/statusList";
import asyncRequest from "@/apis/service/serviceParam/unusualReason";
import addEdit from "./addEdit";
import { mapGetters } from "vuex";

export default {
  name: "unusualReason",
  mixins: [mixinPage, resToken],
  components: {
    addEdit,
  },
  computed: {
    ...mapGetters(["tablebtnSize", "searchSize", "size"]),
    powers() {
      const tran =
        this.$store.getters.btnList.find(
          (item) => item.menu_route == "unusualReason"
        ) || {};
      const { action } = tran ?? {};
      return action ?? [];
    },
  },
  data() {
    return {
      // 状态
      statusOptions: [
        { id: "0", label: "禁用" },
        { id: "1", label: "启用" },
      ],
      options: [
        { id: "1", label: "入库验收异常" },
        { id: "2", label: "退货验收异常" },
        { id: "3", label: "售后已收到货异常" },
        { id: "4", label: "采购退货" },
        { id: "5", label: "销售退换货" },
        { id: "6", label: "售后未收到货异常" },
        { id: "7", label: "议价申请原因" },
        { id: "8", label: "商品下线原因" },
      ],
      statusList: statusList,
      loading: true,
      showModel: false,
      isDetail: false,
      modelId: 0,
      parmValue: {
        status: "", //
        type: "",
        page: 1, // 页码
        size: 15, // 每页显示条数
      },
      tableData: [],
      passwordModel: false,
      passwordModelId: 0,
      isPasswordDetail: false,
      // 表格 - 数据
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns: [
        {
          prop: "result_code",
          label: "原因编号",
          width: "120px",
        },
        {
          prop: "result",
          label: "原因标题",
        },
        {
          prop: "type",
          label: "原因类型",
          _slot_: "type",
          width: "150px",
        },
        {
          prop: "result_desc",
          label: "异常描述",
        },
        {
          prop: "status",
          label: "状态",
          _slot_: "status",
          width: "80px",
        },
        {
          prop: "addtime",
          label: "创建时间",
          sortable: true,
          width: "140px",
        },
        {
          prop: "",
          label: "操作",
          fixed: "right",
          _noset_: true,
          _slot_: "operation",
          width: "150px",
        },
      ],
    };
  },
  mounted() {
    this.searchList();
  },
  methods: {
    async deleteItem(id) {
      await this.$confirm("确定要删除？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          const model = {
            id: id,
          };
          const res = await asyncRequest.delete(model);
          if (res && res.code === 0) {
            this.$notify.success({
              title: "删除成功",
              message: "",
            });
            this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    restSearch() {
      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0,
      };
      this.parmValue = {
        status: "", //
        type: "",
        page: 1, // 页码
        size: 15, // 每页显示条数
      };
      this.searchList();
    },
    openModal(row, type) {
      const { status, id } = row;
      if (type === "005" && status === "1") {
        this.$message.warning("禁用后，才可以修改！");
        return;
      }

      this.modelId = id;
      this.isDetail = type === "007";
      this.sitem = row;
      this.showModel = true;
    },
    async searchList() {
      this.loading = true;
      const res = await asyncRequest.list(this.parmValue);
      if (res && res.code === 0 && res.data) {
        this.tableData = res.data.list;
        // console.log(this.tableData);
        this.pageInfo.total = Number(res.data.count);
      } else if (res && res.code >= 100 && res.code <= 104) {
        await this.logout();
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },

    async statusConfirm(id, status) {
      let str = status === "1" ? "禁用" : "启用";
      await this.$confirm("确定要改为" + str + "?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          this.loading = true;
          const model = {
            id: id,
            status: status === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.loading = false;
            this.$notify.success({
              title: "状态修改成功！",
              message: "",
            });
            await this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
  },
};
</script>
  <style lang="scss" scoped>
</style>
   